package jdk.management.resource.internal.inst;

import jdk.internal.instrumentation.InstrumentationMethod;
import java.io.IOException;
import jdk.management.resource.internal.ResourceIdImpl;
import jdk.management.resource.internal.ApproverGroup;
import java.net.InetAddress;
import jdk.internal.instrumentation.InstrumentationTarget;

@InstrumentationTarget("sun.security.ssl.SSLSocketImpl")
public final class SSLSocketImplRMHooks
{
    public SSLSocketImplRMHooks() {
    }
    
    public final boolean isBound() {
        return this.isBound();
    }
    
    boolean isLayered() {
        return this.isLayered();
    }
    
    public final InetAddress getLocalAddress() {
        return this.getLocalAddress();
    }
    
    @InstrumentationMethod
    private void waitForClose() throws IOException {
        InetAddress localAddress = null;
        if (this.isLayered()) {
            localAddress = this.getLocalAddress();
        }
        if (this.isBound()) {
            ApproverGroup.SOCKET_OPEN_GROUP.getApprover(this).request(-1L, ResourceIdImpl.of(localAddress));
        }
        this.waitForClose();
    }
}
